<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>

    <script src="../lib/snap/SnapResizeDecorator.js"></script>

  </head>
  <body>

    <script>

    const MARGIN = 2
    const WIDTH = 13
    const HEIGHT = 26
    const RIGHT_RSZ_MARGIN_BONUS = 1.5

    setup (() => {
        let snapView = {attr: () => {}};
        let point = {x: 100, y: 100};
        this.leftResizer = new SnapResizeDecorator("LEFT", snapView, point);
        this.rightResizer = new SnapResizeDecorator("RIGHT", snapView, point);
    })

    test('should contain the middle position of left resizer', () => {
        assert.ok(this.leftResizer.contains(100 - WIDTH/2 - MARGIN))
    })

    test('should contain the most left position of the left resizer (spike)', () => {
        assert.ok(this.leftResizer.contains(100 - WIDTH - MARGIN))
    })

    test('should not contain a position beyond the spike point of the left resizer', () => {
        assert.ok(!this.leftResizer.contains(100 - WIDTH - MARGIN - 1))
    })

    test('should contain the most right position of the left resizer', () => {
        assert.ok(this.leftResizer.contains(100 - MARGIN))
    })

    test('should contain a position between the shape and the left resizer', () => {
        assert.ok(this.leftResizer.contains(100 - MARGIN/2))
    })

    test('should not contain the most left position of the shape', () => {
        assert.ok(!this.leftResizer.contains(100))
    })

    test('should contain the middle position of right resizer', () => {
        assert.ok(this.rightResizer.contains(100 + RIGHT_RSZ_MARGIN_BONUS + MARGIN + WIDTH/2))
    })

    test('should contain the the most right position of the right resizer (spike)', () => {
        assert.ok(this.rightResizer.contains(100 + RIGHT_RSZ_MARGIN_BONUS + MARGIN + WIDTH))
    })

    test('should not contain a position beyond the spike point of the right resizer', () => {
        assert.ok(!this.rightResizer.contains(100 + RIGHT_RSZ_MARGIN_BONUS + MARGIN + WIDTH + 1))
    })

    test('should contain the most left position of the right resizer', () => {
        assert.ok(this.rightResizer.contains(100 + RIGHT_RSZ_MARGIN_BONUS + MARGIN))
    })

    test('should contain a position between the shape and the right resizer', () => {
        assert.ok(this.rightResizer.contains(100 + RIGHT_RSZ_MARGIN_BONUS + MARGIN/2))
    })

    test('should not contain the most left position of the shape', () => {
        assert.ok(!this.rightResizer.contains(100 + RIGHT_RSZ_MARGIN_BONUS))
    })

    </script>

  </body>
</html>
